1 CLS:SCREEN 0:KEY OFF:WIDTH 80:PI=3.14159265#
2 REM Smith Chart Impedance Matching/WA9GFR/Ham Radio October 1984, page 120
3 PRINT:PRINT TAB(20);"PROGRAM FOR IMPEDANCE MATCHING"
4 PRINT:PRINT TAB(20);"by Lynn Gerig WA9GFR, March 84"
10 'PRINT:INPUT"DISCRETE FREQUENCIES (D) OR SMOOTH PLOT (S)";D$
11 'IF D$<>"D" AND D$<>"S" THEN 10
12 'INPUT"PLOT WHAT VALUE VSWR CIRCLE";VS:IF VS<1 THEN 12:VR=100*(VS-1)/(VS+1)
13 'VR=100*(VS-1)/(VS+1)
14 PRINT:INPUT"WHAT CHARACTERISTIC IMPEDANCE";ZO
15 INPUT"HOW MANY FREQUENCIES (1-10)";N
16 FOR J=1 TO N
18 PRINT"INPUT FREQUENCY ";J;" IN MHZ":INPUT F(J)
20 PRINT"INPUT RS, XS OF LOAD AT ";F(J);" MHZ":INPUT R(J),I(J)
22 X(J)=R(J): Y(J)=I(J):NEXT
24 CLS:PRINT"THESE WERE YOUR LOAD IMPEDANCE INPUTS"
26 PRINT"    FREQ      RS      XS":PRINT
27 FOR J=1 TO N:F$=STR$(F(J))
28 RS$=STR$(R(J)):XS$=STR$(I(J))
29 PRINT USING"#####.##";VAL(F$);VAL(RS$);VAL(XS$):PRINT:NEXT
32 INPUT"ARE YOU SATISFIED (Y=YES)";A$
34 IF A$<>"Y" THEN GOTO 14
50 CLS:PRINT"CHOOSE TYPE OF MATCHING SECTION"
52 PRINT" 1 SERIES C"
54 PRINT" 2 SERIES L"
56 PRINT" 3 SERIES TUNED (SERIES L-C)"
58 PRINT" 4 SERIES TUNED (PARALLEL L-C)"
60 PRINT" 5 SERIES TRANSMISSION LINE"
62 PRINT" 6 SHUNT C"
64 PRINT" 7 SHUNT L"
66 PRINT" 8 SHUNT TUNED (SERIES L-C)
68 PRINT" 9 SHUNT TUNED (PARALLEL L-C)
70 PRINT"10 SHUNT TRANSMISSION LINE"
72 PRINT"11 TRANSFORMER"
74 PRINT"12 SERIES R"
76 PRINT"13 SHUNT R"
78 PRINT"14 STOP ADDING SECTIONS"
80 PRINT:PRINT:INPUT"CHOICE (1-14)";M
81 IF M<1 OR M>14 THEN 80
82 ON M GOTO 1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000,6500,7000,7500
1000 PRINT"ADD SERIES CAPACITOR"
1002 INPUT"WHAT IS VALUE (IN PF)";C
1004 FOR J=1 TO N
1010 FOR J=1 TO N
1015 X(J)=R(J)
1020 Y(J)=I(J)-1/(2*PI*F(J)*C*1E-06)
1022 NEXT:GOTO 9000
1500 PRINT"ADD SERIES INDUCTOR"
1502 INPUT"WHAT IS VALUE (IN UH)";L
1510 FOR J=1 TO N:X(J)=R(J)
1512 Y(J)=I(J)+2*PI*F(J)*L:NEXT:GOTO 9000
2000 PRINT"ADD SERIES TUNED (SERIES L-C)"
2002 INPUT"WHAT IS VALUE OF C (IN PF)";C
2004 INPUT"WHAT IS VALUE OF L (IN UH)";L
2010 FOR J=1 TO N:X(J)=R(J)
2020 Y(J)=I(J)+2*PI*F(J)*L-1/(2*PI*F(J)*C*1E-06):NEXT:GOTO 9000
2500 PRINT"ADD SERIES TUNED (PARALLEL L-C)"
2502 INPUT"WHAT IS VALUE OF C (IN PF)";C
2504 INPUT"WHAT IS VALUE OF L (IN UH)";L
2510 FOR J=1 TO N:X(J)=R(J)
2520 Y(J)=I(J)+(2*PI*F(J)*L)/(1-((2*PI*F(J))^2)*L*C*1E-06):NEXT:GOTO 9000
3000 PRINT"ADD SERIES TRANSMISSION LINE"
3002 INPUT"WHAT IS LINE IMPEDANCE (OHMS)";Z1
3004 INPUT"WHAT IS VELOCITY FACTOR";V
3006 INPUT"WHATIS LENGTH (IN INCHES)";LL
3010 FOR J=1 TO N
3014 T=1.2*LL*F(J)/39.37/V
3016 D=(R(J)+Z1)^2+I(J)^2
3020 D=(R(J)+Z1)^2+I(J)^2
3024 R=(R(J)^2-Z1^2+I(J)^2)/D
3025 R=(R(J)^2-Z1^2+I(J)^2)/D
3030 I=2*Z1*I(J)/D
3035 Z=SQR(R*R+I*I)
3040 T=180/PI*ATN(I/(R+1E-30))-2*T+180*(R<0)
3045 R=Z*COS(T*PI/180)
3050 I=Z*SIN(T*PI/180)
3055 D=(1-R)^2+I^2
3060 X(J)=Z1*(1-R^2-I^2)/D
3065 Y(J)=2*Z1*I/D
3070 NEXT:GOTO 9000
3500 PRINT"ADD SHUNT CAPACITOR"
3502 INPUT"WHAT IS VALUE OF C (IN PF)";C
3506 FOR J=1 TO N: W=2*PI*C*1E-06
3508 D=(1-W*F(J)*I(J))^2+(R(J)*W*F(J))^2
3510 X(J)=R(J)/D
3515 Y(J)=(I(J)*(1-W*F(J)*I(J))-R(J)^2*W*F(J))/D:NEXT:GOTO 9000
4000 PRINT"ADD SHUNT INDUCTOR"
4005 INPUT"WHAT IS VALUE OF L (IN UH)";L
4015 FOR J=1 TO N:W=2*PI*F(J)*L
4025 D=R(J)^2+(I(J)+W)^2
4030 X(J)=R(J)*W^2/D
4035 Y(J)=W*(R(J)^2+I(J)^2+W*I(J))/D
4040 NEXT:GOTO 9000
4500 PRINT "ADD SHUNT TUNED (SERIES L-C)"
4505 INPUT"WHAT IS VALUE OF C (IN PF)";C
4506 INPUT"WHAT IS VALUE OF L (IN UH)";L
4510 FOR J=1 TO N
4515 W=2*PI*F(J)*L-(1000000!)/(2*PI*F(J)*C)
4517 D=R(J)^2+(I(J)+W)^2
4520 X(J)=R(J)*W^2/D
4525 Y(J)=W*(R(J)^2+I(J)^2+W*I(J))/D
4530 NEXT:GOTO 9000
5000 PRINT"ADD SHUNT TUNED (PARALLEL L-C)"
5005 INPUT"WHAT IS VALUE OF C (IN PF)";C
5006 INPUT "WHATIS VALUE OF L (IN UH)";L
5010 FOR J=1 TO N
5015 W=(2*PI*F(J)*L)/(1-((2*PI*F(J))^2)*L*C*1E-06)
5020 D=R(J)^2+(I(J)+W)^2
5025 X(J)=R(J)*W^2/D
5030 Y(J)=W*(R(J)^2+I(J)^2+W*I(J))/D
5035 NEXT:GOTO 9000
5500 PRINT"ADD SHUNT TRANSMISSION LINE"
5502 INPUT"WHAT IS LINE IMPEDANCE (OHMS)";Z1
5504 INPUT"WHAT IS LINE VELOCITY FACTOR";V
5505 INPUT"WHAT IS LENGTH (IN INCHES)";LL
5506 PRINT"OPEN (O) OR SHORTED (S) STUB";
5510 INPUT S$
5515 IF S$<>"O" AND S$<>"S" THEN 5510
5520 FOR J=1 TO N
5525 T=LL*F(J)*1.2/39.37/V
5530 IF S$="S" THEN W=Z1*TAN(T*PI/180)
5535 IF S$="O" THEN W=Z1*TAN((T+90)*PI/180)
5540 D=R(J)^2+(I(J)+W)^2
5545 X(J)=R(J)*W^2/D
5550 Y(J)=W*(R(J)^2+I(J)^2+W*I(J))/D
5555 NEXT:GOTO 9000
6000 PRINT"ADD TRANSFORMER"
6002 INPUT"STEP UP OR DOWN (U OR D)";T$
6004 IF T4<>"U" AND T$<>"D" THEN 6000
6006 INPUT"WHAT TRANSFORMATION RATIO";W
6010 IF T$="D" THEN W=1/W
6020 FOR J=1 TO N: X(J)=W*R(J)
6025 Y(J)=W*I(J):NEXT:GOTO 9000
6500 PRINT"ADD SERIES RESISTOR"
6502 INPUT"WHAT IS VALUE OF RESISTOR";RS
6507 FOR J=1 TO N:X(J)=R(J)+RS
6510 Y(J)=I(J):NEXT:GOTO 9000
7000 PRINT"ADD SHUNT RESISTOR"
7005 INPUT"WHAT VALUE OF R";RS: FOR J=1 TO N
7006 D=(R(J)+RS)^2+I(J)^2
7008 X(J)=RS*(R(J)^2+RS*R(J)+I(J)^2)/D
7010 Y(J)=I(J)*RS^2/D:NEXT:GOTO 9000
7500 PRINT
7505 INPUT"WANT TO RUN ANOTHER ONE";A$
7510 IF LEFT$(A$,1)="Y" THEN 10
7515 PRINT"GOOD-BYE":END
9000 PRINT"   FREQ      RS      XS":PRINT
9005 FOR J=1 TO N
9010 RS$=STR$(X(J))
9015 XS$=STR$(Y(J))
9020 F$=STR$(F(J))
9025 PRINT USING"#####.##";VAL(F$),VAL(RS$),VAL(XS$):PRINT
9030 NEXT
9200 FOR J=1 TO N:R(J)=X(J)
9210 I(J)=Y(J):NEXT
9215 PRINT"YOU MUST NOW MATCH THE IMPEDANCES LISTED ABOVE": FOR Y=1 TO 3000:NEXT:GOTO 50
